<?php
/**
 * Joomla! 1.5 component Collector
 *
 * @version 	$Id: field.date.php 135 2012-04-08 11:41:45Z steevo $
 * @author 		Philippe Ousset steevo@steevo.fr
 * @package 	Collector
 * @license 	GNU/GPL
 *
 * Collector is a Multi Purpose Listing Tool.
 * Originaly developped to list Collections
 * it can be used for several purpose.
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

/**
 * Field Date class
 *
 * @package	Collector
 */
class CollectorField_Date extends CollectorField
{
	/**
	 * type
	 * 
	 * @var string
	 */
	public $type = 'date';
	
	/**
	 * Object constructor to set field
	 *
	 * Can be overloaded/supplemented by the child class
	 *
	 * @access	protected
	 * @param	int								$collection	Collection Id
	 * @param	object TableCollector_fields	$field		TableCollector_fields object
	 * @param	int								$item		Item Id
	 */
	function __construct( $collection, $field, $item = 0 )
	{
		// Initialisation
		$this->_collection = $collection;
		$this->_item = $item;
		$this->_field = $field;
	}
	
	/**
	 * Gets the field attributes for the form definition
	 *
	 * @return string
	 */
	function getFieldAttributes()
	{
		$attributes = array(
			'class'			=> "inputbox",
			'size'			=> "22",
			'format'		=> $this->_field->attribs['format'],
			'filter'		=> "user_utc"
		);
		
		return parent::getFieldAttributes($attributes);
	}
	
	/**
	 * Method to display field
	 *
	 * Can be overloaded/supplemented by the child class
	 *
	 * @param	string		$value		Field value
	 * @param	boolean		$listing	Field value
	 */
	function display($value,$listing=true)
	{
		$format = $this->_field->attribs['format'];
		if ( $format == '' )
		{
			$format = '%Y-%m-%d';
		}
		if ($value != 0) {
			echo JHTML::_( 'date', $value, $format);
		}
		return;
	}
}

require_once(JPATH_ROOT.DS.'libraries'.DS.'joomla'.DS.'form'.DS.'fields'.DS.'calendar.php');

/**
 * Form Field class for the Collector.
 *
 * @package		Collector
 */
class JFormFieldCollectorDate extends JFormFieldCalendar
{
	public $type 		= 'CollectorDate';
}