<?php
/**
 * Joomla! 1.5 component Collector
 *
 * @version 	$Id: collector.php 122 2011-09-13 22:26:20Z steevo $
 * @author 		Philippe Ousset steevo@steevo.fr
 * @package 	Collector
 * @license 	GNU/GPL
 *
 * Collector is a Multi Purpose Listing Tool.
 * Originaly developped to list Collections
 * it can be used for several purpose.
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

// collector ACL 
if(version_compare(JVERSION,'1.6.0','<')){
	//Code pour Joomla! 1.5
	$auth =& JFactory::getACL();

	$auth->addACL('com_collector', 'filemanage', 'users', 'super administrator');
	$auth->addACL('com_collector', 'templatemanage', 'users', 'super administrator');
	
	// Require the base controller
	require_once(JPATH_COMPONENT.DS.'controller.php');

	// Require specific controller if requested
	if($controller = JRequest::getWord('controller')) {
		$path = JPATH_COMPONENT.DS.'controllers'.DS.$controller.'.php';
		if (file_exists($path)) {
			require_once $path;
		} else {
			$controller = '';
		}
	}

	// Create the controller
	$classname = 'CollectorsController'.$controller;
	$controller = new $classname();

	// Perform the Request task
	$controller->execute(JRequest::getVar('task'));

	// Redirect if set by the controler
	$controller->redirect();
}
else
{
	//Code pour Joomla >= 1.6.0
	// Access check.
	if (!JFactory::getUser()->authorise('core.manage', 'com_collector'))
	{
		return JError::raiseWarning(404, JText::_('JERROR_ALERTNOAUTHOR'));
	}
	
	// require helper file
	JLoader::register('CollectorHelper', dirname(__FILE__) . DS . 'helpers' . DS . 'collector.php');
	
	// import joomla controller library
	jimport('joomla.application.component.controller');
	 
	// Get an instance of the controller prefixed by Collector
	$controller = JController::getInstance('Collector');
	 
	// Perform the Request task
	$controller->execute(JRequest::getCmd('task'));
	 
	// Redirect if set by the controller
	$controller->redirect();
}


