<?php
/**
 * Joomla! 1.5 component Collector
 *
 * @version 	$Id: history.php 120 2011-09-04 22:33:31Z steevo $
 * @author 		Philippe Ousset steevo@steevo.fr
 * @package 	Collector
 * @license 	GNU/GPL
 *
 * Collector is a Multi Purpose Listing Tool.
 * Originaly developped to list Collections
 * it can be used for several purpose.
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.application.component.controller');

/**
 * History Controller
 *
 * @package  	Collector
 */
class CollectorsControllerHistory extends CollectorsController
{
	/**
	 * Cancels an edit history operation
	 *
	 * @access	public
	 */
	function cancel()
	{
		$option = JRequest::getCmd( 'option' );
		$collection = JRequest::getCmd( 'collection' );
		
		$this->setRedirect( 'index.php?option='.$option.'&view=items&collection='.$collection, $msg );
	}
	
	/**
	 * Method to delete an history
	 *
	 * @access	public
	 */
	function remove()
	{
		$option = JRequest::getCmd( 'option' );
		$view = JRequest::getCmd( 'view' );
		$collection = JRequest::getCmd( 'collection' );
		$id = JRequest::getVar( 'itemId', '', '', 'int');
		
		$model = $this->getModel('itemhistory');
		
		$msg = $model->remove();
		
		$this->setRedirect( 'index.php?option='.$option.'&view='.$view.'&collection='.$collection.'&itemId='.$id, $msg );
	}
	
	/**
	 * Method to reset hits item
	 *
	 * @access	public
	 */
	function resethits()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		// Initialize variables
		$option = JRequest::getCmd( 'option' );
		$collection = JRequest::getCmd( 'collection' );
		$id = JRequest::getCmd( 'itemId' );
		
		$model = $this->getModel('itemedit');
		
		if ($model->resetHits($id))
		{
			$msg = JText::_('COM_COLLECTOR_SUCCESSFULLY_RESET_HIT_COUNT');
		}
		else
		{
			$msg = JText::_('COM_COLLECTOR_ERROR_SAVE');
		}
		
		$this->setRedirect( 'index.php?option='.$option.'&view=itemhistory&collection='.$collection.'&itemId='.$id, $msg );
	}
	
	/**
	 * Method to display a view
	 *
	 * @access	public
	 */
	function display()
	{
		parent::display();
	}
}