<?php
/**
 * Joomla! 1.5 component Collector
 *
 * @version 	$Id: menu.php 120 2011-09-04 22:33:31Z steevo $
 * @author 		Philippe Ousset steevo@steevo.fr
 * @package 	Collector
 * @license 	GNU/GPL
 *
 * Collector is a Multi Purpose Listing Tool.
 * Originaly developped to list Collections
 * it can be used for several purpose.
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.application.component.controller');

/**
 * Menu Controller
 *
 * @package  	Collector
 */
class CollectorsControllerMenu extends CollectorsController
{
	/**
	 * Method to load filter fields in menu edition
	 */
	function listFilter()
	{
		$db =& JFactory::getDBO(); 
		$collection = JRequest::getVar( 'collection', '', '', 'int');
		$menuId = JRequest::getVar( 'itemId', '', '', 'int');
		$menuparams = null;
		
		if ( $menuId != 0 )
		{
			$query = 'SELECT params';
			$query .= ' FROM `#__menu`';
			$query .= ' WHERE id = \''.$menuId.'\'';
			
			$db->setQuery( $query );
			
			$params = $db->loadResult();
			$paramsArray = explode("\n", $params);
			
			foreach ( $paramsArray AS $param )
			{
				$param = explode("=", $param);
				$menuparams[$param[0]] = $param[1];
			}
		}
		
		if ( $collection == 0 )
		{
			$code[] = JText::_('COM_COLLECTOR_SELECT_COLLECTION');
		}
		else
		{
			$query = 'SELECT id, field, defined';
			$query .= ' FROM `#__collector_fields`';
			$query .= ' WHERE collection = \''.$collection.'\'';
			$query .= ' AND type = \'3\'';
			
			$db->setQuery( $query );
			
			$fields = $db->loadObjectList();
			
			if ($fields == null)
			{
				$code[] = JText::_('COM_COLLECTOR_NO_FILTER_AVAILABLE');
			}
			else
			{
				foreach ( $fields AS $field )
				{
					$paramName = 'filterfield_'.$field->id;
					
					if ( $menuparams != null )
					{
						if ( isset($menuparams[$paramName]) )
						{
							$default = $menuparams[$paramName];
						}
						else
						{
							$default = 0;
						}
					}
					
					$init[0] = array('value' => '', 'text' => ' - ' . JText::_('COM_COLLECTOR_SELECT').' - ');
					
					$query = 'SELECT id AS value, content AS text ';
					$query .= ' FROM #__collector_defined_content';
					$query .= ' WHERE defined = \'' . $field->defined .'\'';
					$db->setQuery( $query );
					
					$results = $db->loadObjectList();
					
					//Check for database error
					if (!$db->query())
					{
						$this->setRedirect( 'index.php?option=com_collector' );
						return JError::raiseWarning( 500, $db->getErrorMsg() );
					}
					
					$select = $init;
					foreach ( $results as $key => $value )
					{
						$select[$key+1]=$value;
					}
					
					$code[] = ' * '.$field->field . ' :';
					$code[] = JHTML::_('select.genericlist', $select, 'params[filterfield_'.$field->id.']', ' class=inputbox size="1" ', 'value', 'text', $default);
				}
			}
		}
		
		echo implode('<br/>',$code);
		return;
	}
	
	/**
	 * Method to load items list in menu edition
	 */
	function listItems()
	{
		$db =& JFactory::getDBO(); 
		// recuperation du titre personnalise pour la collection
		$collection = JRequest::getVar( 'collection', '', '', 'int');

		if ( $collection == 0 )
		{
			$code = JText::_('COM_COLLECTOR_SELECT_COLLECTION');
		}
		else
		{
			$menuId = JRequest::getVar( 'itemId', '', '', 'int');
			$menuparams = null;
			$default = 0;

			if ( $menuId != 0 )
			{
				$query = 'SELECT link';
				$query .= ' FROM `#__menu`';
				$query .= ' WHERE id = \''.$menuId.'\'';
				
				$db->setQuery( $query );
				
				$params = $db->loadResult();
				$paramsArray = explode("&", $params);
				
				foreach ( $paramsArray AS $param )
				{
					$param = explode("=", $param);
					$menuparams[$param[0]] = $param[1];
				}
			}
			
			if ( ( $menuparams != null ) AND ( isset($menuparams['item']) ) )
			{
				$default = $menuparams['item'];
			}

			$query = 'SELECT custom';
			$query .= ' FROM `#__collector`';
			$query .= ' WHERE id = \'' . $collection . '\'';

			$db->setQuery( $query );

			$row = $db->loadObjectList();

			if ( $row[0]->custom == "0" )
			{
				$query = 'SELECT id';
				$query .= ' FROM `#__collector_fields`';
				$query .= ' WHERE collection = "' . $collection . '"';
				$query .= ' AND home = "1"';

				$db->setQuery( $query );

				$row = $db->loadObjectList();

				$custom[] = $row[0]->id;
			}
			else
			{
				$custom = explode( '/', $row[0]->custom );
			}

			$query = 'SELECT id, field, type, defined';
			$query .= ' FROM `#__collector_fields`';
			$query .= ' WHERE collection = \'' . $collection . '\'';

			$db->setQuery( $query );

			$results = $db->loadObjectList();

			$i = 0;

			foreach ( $custom as $field )
			{
				for ($j = 0; $j < count($results); $j ++)
				{
					$number_field_default[$i] = $field;

					if ( $results[$j]->id == $field )
					{
						$name_field_default[$i] = $results[$j]->field;
						if ( $results[$j]->type == 3 )
						{
							$defined_field_default[$i] = $results[$j]->defined;
						}
						else
						{
							$defined_field_default[$i] = null;
						}
					}
				}
				$i++;
			}

			// recherche des objets de la collection
			//$query = 'SELECT c.id, c.state, ordering, hits, created, created_by, u.name AS author, created_by_alias, access, g.name AS groupname, publish_up, publish_down, ';
			$query = 'SELECT c.id';
			for ( $i=0; $i < count($number_field_default); $i ++ )
			{
				if ($defined_field_default[$i])
				{
					$query .= ', d'.$i.'.content AS name'.$i;
				}
				else
				{
					$query .= ', v'.$i.'.value AS name'.$i;
				}
			}
			$query .= ' FROM `#__collector_items` AS c';
			$query .= ' LEFT JOIN `#__users` AS u ON c.created_by = u.id';
			$query .= ' LEFT JOIN `#__groups` AS g ON c.access = g.id';
			$query .= ' LEFT JOIN `#__collector_items_history` AS h ON h.item = c.id';
			for ( $i=0; $i < count($number_field_default); $i ++ )
			{
				$query .= ' LEFT JOIN `#__collector_items_values` AS v'.$i.' ON v'.$i.'.history = h.id AND v'.$i.'.field = '.$number_field_default[$i];

				if ($defined_field_default[$i])
				{
					$query .= ' LEFT JOIN `#__collector_defined_content` AS d'.$i.' ON d'.$i.'.id = v'.$i.'.value';
				}
			}

			$query .= ' WHERE c.collection = ' . $collection . ' AND h.state = 1';
			$query .= ' ORDER BY c.ordering';

			$db->setQuery( $query );

			$results = $db->loadObjectList();

			foreach ( $results as $row )
			{
				$item = new stdClass;
				$item->value = $row->id;

				$name = $row->name0;

				for ($j=1; $j<count($number_field_default); $j ++)
				{
					$field = 'name'.$j;
					$name .= ' ' . $row->$field;
				}

				$item->text = $name;

				$items[] = $item;
			}
			
			$init[0] = array('value' => '', 'text' => ' - ' . JText::_('COM_COLLECTOR_SELECT_AN_ITEM').' - ');
			$select = $init;
			foreach ( $items as $key => $value )
			{
				$select[$key+1]=$value;
			}
			
			$code = JHTML::_('select.genericlist', $select, 'urlparams[item]', ' class=inputbox size="1" ', 'value', 'text', $default);
		}
		
		echo $code;
		return;
	}

}