<?php
/**
 * Joomla! 1.5 component Collector
 *
 * @version 	$Id: collector.php 120 2011-09-04 22:33:31Z steevo $
 * @author 		Philippe Ousset steevo@steevo.fr
 * @package 	Collector
 * @license 	GNU/GPL
 *
 * Collector is a Multi Purpose Listing Tool.
 * Originaly developped to list Collections
 * it can be used for several purpose.
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

/**
 * Renders a collector element
 *
 * @package		Collector
 */
class JElementCollector extends JElement
{
	/**
	 * Element name
	 *
	 * @access	protected
	 * @var		string
	 */
	var	$_name = 'Collector';

	function fetchElement($name, $value, &$node, $control_name)
	{
		$db =& JFactory::getDBO();
		$doc =& JFactory::getDocument();

		if ( $name == 'id' )
		{
			$task = 'listFilter';
			$area = 'listFilter';
		}
		else if ( $name == 'collection' )
		{
			$task = 'listItems';
			$area = 'listItems';
		}
		
		$js = "
		window.addEvent( 'domready', function() {
			$('".$control_name.$name."').addEvent( 'change', function() {
				var form = document.adminForm;
				var itemId = form.id.getValue();
				var collection = this.getValue();
				var url='index.php?option=com_collector&controller=menu&format=raw&task=".$task."&collection='+collection+'&itemId='+itemId;
				var a = new Ajax( url, {
					method: 'get',
					update:$('".$area."')
				}).request();
			});
		});";
		$doc->addScriptDeclaration($js);

		$query = 'SELECT a.id, a.name, a.alias'
		. ' FROM #__collector AS a'
		. ' ORDER BY a.name'
		;
		$db->setQuery( $query );
		$options = $db->loadObjectList();

		foreach ($options as $option)
		{
			$option->id = $option->id . ':' . $option->alias;
		}

		array_unshift($options, JHTML::_('select.option', '0', '- '.JText::_('COM_COLLECTOR_SELECT_COLLECTION').' -', 'id', 'name'));

		return JHTML::_('select.genericlist',  $options, ''.$control_name.'['.$name.']', 'class="inputbox"', 'id', 'name', $value, $control_name.$name );
	}
}
