<?php
/**
 * Joomla! 1.5 component Collector
 *
 * @version 	$Id: customtitle.php 126 2011-11-09 21:54:29Z steevo $
 * @author 		Philippe Ousset steevo@steevo.fr
 * @package 	Collector
 * @license 	GNU/GPL
 *
 * Collector is a Multi Purpose Listing Tool.
 * Originaly developped to list Collections
 * it can be used for several purpose.
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');
 
jimport('joomla.form.formfield');

/**
 * Form Field class for the Collector.
 *
 * @package		Collector
 */
class JFormFieldCustomTitle extends JFormField
{
	protected $type 		= 'CustomTitle';
	
	protected function getInput()
	{
		// Mise en forme du titre personnalise
		if ( $this->value == 0 )
		{
			$this->value = array();
		}
		else
		{
			$this->value = explode( "/", $this->value );
		}
		
		$select = $this->getFieldSelect();
		
		if ($select == 0)
		{
			$html = '<input type="text" value="'.JText::_('COM_COLLECTOR_FIELD_CUSTOM_TITLE_UNABLE').'" disabled="disabled" />';
			$html .= '<input type="hidden" name="custom" value="0" />';
		}
		else
		{		
			$html = '';
			$i = 0;
			foreach ( $this->value as $field )
			{
				$html .= JHTML::_('select.genericlist', $select, $this->name.'[]', ' class=inputbox size="1" onchange="custom_change('.$i.')"', 'value', 'text', $field);
				$i++;
			}
			$html .= JHTML::_('select.genericlist', $select, $this->name.'[]', ' class=inputbox size="1" onchange="custom_change('.$i.')"', 'value', 'text', 0);
		}
		
		return $html;
	}
	
	protected function getFieldSelect()
	{
		// Get collection Id
		$collection = JRequest::getVar('id', 0, '', 'int' );
		
		$init[] = array('value' => 0, 'text' => '');
		
		// Create a new query object.
		$db =& JFactory::getDBO();
		$query = $db->getQuery(true);
		
		// Select the required fields from the table.
		$query->select('id AS value, field AS text');
		$query->from('#__collector_fields');
		
		// Filter by collection
		$query->where('collection='.$collection);
		
		// Filter by field type
		$query->where('type IN (\'1\', \'3\', \'4\', \'6\', \'7\')');
		
		// Add the list ordering clause.
		$query->order('ordering');
		
		$db->setQuery( $query );
		
		$results = $db->loadObjectList();
		//Check for database error
		if (!$db->query())
		{
			return JError::raiseWarning( 500, $db->getErrorMsg() );
		}
		
		if ( count($results) == 0 )
		{
			$select = 0;
		}
		else
		{
			$select = $init;
			foreach ( $results as $key => $value )
			{
				$select[$key+1]=$value;
			}
		}
		
		return $select;
	}
}
?>