<?php
/**
 * Joomla! 1.5 component Collector
 *
 * @version 	$Id: imageselect.php 126 2011-11-09 21:54:29Z steevo $
 * @author 		Philippe Ousset steevo@steevo.fr
 * @package 	Collector
 * @license 	GNU/GPL
 *
 * Collector is a Multi Purpose Listing Tool.
 * Originaly developped to list Collections
 * it can be used for several purpose.
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');
 
jimport('joomla.form.formfield');

/**
 * Form Field class for the Collector.
 *
 * @package		Collector
 */
class JFormFieldImageselect extends JFormField
{
	protected $type 		= 'Imageselect';
	
	protected function getInput()
	{
		// Initialize variables.
		$html = array();
		
		// Get List Details
		$list = $this->getListDetails($this->value);
		
		$html[] = '<input type="text" onChange="setImage(\'image\',\'0\');" name="jform[image]" id="image" value="'.htmlspecialchars($this->value, ENT_QUOTES).'" size="60" maxlength="254" />';
		
		$html[] = '<div class="button2-left"><div class="image"><a class="modal" rel="{handler: \'iframe\', size: {x: 550, y: 537}}" href="'.JRoute::_('index.php?option=com_collector&amp;view=fileselect&amp;tmpl=component&amp;folder='.$list->folder.'&amp;field=image&amp;type=1').'">'.JText::_('COM_COLLECTOR_SELECT_IMAGE').'</a></div></div>';
		
		$html[] = '<img style="clear:both;margin-left:140px;" src="'.JURI::root() . $this->value.'" alt="'.$this->value.'" width="'.$list->width.'" height="'.$list->height.'" name="image-preview" id="image-preview" >';
		
		return implode($html);
	}
	
	protected function getListDetails($image)
	{
		$list->defined = JRequest::getVar( 'defined', '', '', 'int');
		
		$db =& JFactory::getDBO(); 
		
		$query = 'SELECT id, alias, width, height';
		$query .= ' FROM #__collector_defined';
		$query .= ' WHERE id=' . $list->defined;
		
		$db->setQuery( $query );
		
		$result = $db->loadObject();
		
		if ( $image == '' )
		{
			$result->folder = 'images/collector/defined/'.$result->alias;
		}
		else
		{
			$path = explode('/',$image);
			unset($path[sizeof($path)-1]);
			$result->folder = implode('/',$path);
		}
		
		return $result;
	}
}
?>