<?php
/**
 * Joomla! 1.5 component Collector
 *
 * @version 	$Id: requiredfilter.php 134 2012-04-05 20:45:38Z steevo $
 * @author 		Philippe Ousset steevo@steevo.fr
 * @package 	Collector
 * @license 	GNU/GPL
 *
 * Collector is a Multi Purpose Listing Tool.
 * Originaly developped to list Collections
 * it can be used for several purpose.
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.form.formfield');

/**
 * Renders a filter field element
 *
 * @package		Collector
 */
class JFormFieldRequiredfilter extends JFormField
{
	protected $type			= 'Requiredfilter';

	protected function getInput()
	{
		// Initialize variables.
		$html = array();
		$db =& JFactory::getDBO();
		$doc =& JFactory::getDocument();

		$js = "
		window.addEvent( 'domready', function() {
			var form = document.adminForm;
			var itemId = $('jform_id').get('value');
			var collection = $('jform_request_id').get('value');
			var url='index.php?option=com_collector&format=raw&view=menu&tmpl=component&task=menu.listRequired&collection='+collection+'&itemId='+itemId;
			var myRequest = new Request({
				url: url,
				method:'post',
				onComplete: function( response ) {
					$('listRequired').set('html',response);
				}
			});
			myRequest.send();
		});";
		
		$doc->addScriptDeclaration($js);

		$html[] = '<div id=listRequired class="fltlft">'.JText::_('COM_COLLECTOR_SELECT_COLLECTION');
		$html[] = '<input type="hidden" name="'.$this->name.'" value="'.$this->value.'"/>';
		$html[] = '</div>';
		return implode($html);
	}
}
