<?php
/**
 * Joomla! 1.5 component Collector
 *
 * @version 	$Id: view.html.php 124 2011-09-18 21:51:13Z steevo $
 * @author 		Philippe Ousset steevo@steevo.fr
 * @package 	Collector
 * @license 	GNU/GPL
 *
 * Collector is a Multi Purpose Listing Tool.
 * Originaly developped to list Collections
 * it can be used for several purpose.
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.application.component.view');

if(version_compare(JVERSION,'1.6.0','<')){
//Code pour Joomla! 1.5

/**
 * HTML Collections View class for the Collector component
 *
 * @package	Collector
 */
class CollectorsViewCollections extends JView
{
	/**
	 * Display function
	 */
	function display($tpl = null)
	{
		$user =& JFactory::getUser();
		
		JToolBarHelper::title( JText::_( 'COM_COLLECTOR_COL_MANAGER' ), 'categories' );
		
		JToolBarHelper::makeDefault( 'setdefault' );
		JToolBarHelper::archiveList();
		JToolBarHelper::unarchiveList();
		JToolBarHelper::publishList();
		JToolBarHelper::unpublishList();
		JToolBarHelper::deleteList();
		JToolBarHelper::editListX();
		JToolBarHelper::addNewX();
		
		JSubMenuHelper::addEntry( JText::_('COM_COLLECTOR_HOME'), 'index.php?option=com_collector');
		if ($user->authorize('com_collector', 'filemanage')) {
			JSubMenuHelper::addEntry( JText::_('COM_COLLECTOR_FILE_MANAGER'), 'index.php?option=com_collector&view=filemanager');
		}
		JSubMenuHelper::addEntry( JText::_('COM_COLLECTOR_COLLECTIONS'), 'index.php?option=com_collector&view=collections', true );
		JSubMenuHelper::addEntry( JText::_('COM_COLLECTOR_LISTS'), 'index.php?option=com_collector&view=defined');
		
		JHTML::_('behavior.tooltip');
		
		// Get data from the model
		$model =& $this->getModel('collections');
		$items =& $model->getData();
		
		$pagination =& $model->getPagination();
		
		$this->assignRef( 'items', $items );
		$this->assignRef( 'pagination', $pagination );
		
		if ( !empty($this->items) )
		{
			JSubMenuHelper::addEntry( JText::_('COM_COLLECTOR_FIELDS'), 'index.php?option=com_collector&view=collectionfields');
			JSubMenuHelper::addEntry( JText::_('COM_COLLECTOR_ITEMS'), 'index.php?option=com_collector&view=items');
			if ($user->authorize('com_collector', 'templatemanage')) {
				JSubMenuHelper::addEntry( JText::_('COM_COLLECTOR_TEMPLATES'), 'index.php?option=com_collector&view=templates');
			}
		}
		
		parent::display($tpl);
	}
}

}else{
//Code pour Joomla >= 1.6.0
/**
 * HTML Collections View class for the Collector component
 *
 * @package	Collector
 */
class CollectorViewCollections extends JView
{
	protected $items;
	protected $pagination;
	protected $state;

	/**
	 * Display the view
	 *
	 * @return	void
	 */
	public function display($tpl = null)
	{
		$this->items		= $this->get('Items');
		$this->pagination	= $this->get('Pagination');
		$this->state		= $this->get('State');
		
		// Check for errors.
		if (count($errors = $this->get('Errors'))) {
			JError::raiseError(500, implode("\n", $errors));
			return false;
		}

		// We don't need toolbar in the modal window.
		if ($this->getLayout() !== 'modal') {
			$this->addToolbar();
		}

		parent::display($tpl);
	}

	/**
	 * Add the page title and toolbar.
	 */
	protected function addToolbar()
	{
		$canDo	= CollectorHelper::getActions();
		$user		= JFactory::getUser();
		JToolBarHelper::title(JText::_('COM_COLLECTOR_COL_MANAGER'), 'categories.png');

		if ($canDo->get('core.create') || (count($user->getAuthorisedCategories('com_collector', 'core.create'))) > 0 ) {
			JToolBarHelper::addNew('collection.add','JTOOLBAR_NEW');
		}

		if (($canDo->get('core.edit')) || ($canDo->get('core.edit.own'))) {
			JToolBarHelper::editList('collection.edit','JTOOLBAR_EDIT');
		}

		if ($canDo->get('core.edit.state')) {
			JToolBarHelper::divider();
			JToolBarHelper::custom('collections.publish', 'publish.png', 'publish_f2.png','JTOOLBAR_PUBLISH', true);
			JToolBarHelper::custom('collections.unpublish', 'unpublish.png', 'unpublish_f2.png', 'JTOOLBAR_UNPUBLISH', true);
			JToolBarHelper::custom('collections.setDefault', 'default.png', 'featured_f2.png', 'JDEFAULT', true);			
			JToolBarHelper::divider();
			JToolBarHelper::archiveList('collections.archive','JTOOLBAR_ARCHIVE');
			JToolBarHelper::custom('collections.checkin', 'checkin.png', 'checkin_f2.png', 'JTOOLBAR_CHECKIN', true);
		}

		if ($this->state->get('filter.published') == -2 && $canDo->get('core.delete')) {
			JToolBarHelper::deleteList('', 'collections.delete','JTOOLBAR_EMPTY_TRASH');
		}
		else if ($canDo->get('core.edit.state')) {
			JToolBarHelper::trash('collections.trash','JTOOLBAR_TRASH');
		}
	}
}
}
