<?php
/**
 * Joomla! 1.5 component Collector
 *
 * @version 	$Id: view.html.php 126 2011-11-09 21:54:29Z steevo $
 * @author 		Philippe Ousset steevo@steevo.fr
 * @package 	Collector
 * @license 	GNU/GPL
 *
 * Collector is a Multi Purpose Listing Tool.
 * Originaly developped to list Collections
 * it can be used for several purpose.
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.application.component.view');

if(version_compare(JVERSION,'1.6.0','<')){
//Code pour Joomla! 1.5

/**
 * HTML Defined View class for the Collector component
 *
 * @package	Collector
 */
class CollectorsViewDefined extends JView
{
	/**
	 * Display function
	 */
	function display($tpl = null)
	{
		global $mainframe, $option;
		
		$user =& JFactory::getUser();
		
		// Get data from the model
		$model =& $this->getModel('defined');
		$items =& $model->getData();
		$is_collection = $model->collection_exist();
		
		$pagination =& $model->getPagination();
		
		JToolBarHelper::title( JText::_( 'COM_COLLECTOR_LISTS_MANAGER' ), 'sections' );
		
		JToolBarHelper::deleteList();
		JToolBarHelper::editListX();
		JToolBarHelper::addNewX();
		
		JSubMenuHelper::addEntry( JText::_('COM_COLLECTOR_HOME'), 'index.php?option=com_collector');
		if ($user->authorize('com_collector', 'filemanage')) {
			JSubMenuHelper::addEntry( JText::_('COM_COLLECTOR_FILE_MANAGER'), 'index.php?option=com_collector&view=filemanager');
		}
		JSubMenuHelper::addEntry( JText::_('COM_COLLECTOR_COLLECTIONS'), 'index.php?option=com_collector&view=collections');
		JSubMenuHelper::addEntry( JText::_('COM_COLLECTOR_LISTS'), 'index.php?option=com_collector&view=defined', true);
		if ( $is_collection != 0 )
		{
			JSubMenuHelper::addEntry( JText::_('COM_COLLECTOR_FIELDS'), 'index.php?option=com_collector&view=collectionfields');
			JSubMenuHelper::addEntry( JText::_('COM_COLLECTOR_ITEMS'), 'index.php?option=com_collector&view=items');
			if ($user->authorize('com_collector', 'templatemanage')) {
				JSubMenuHelper::addEntry( JText::_('COM_COLLECTOR_TEMPLATES'), 'index.php?option=com_collector&view=templates');
			}
		}
		
		JHTML::_('behavior.tooltip');
		
		if(version_compare(JVERSION,'1.6.0','<')){
			//Code pour Joomla! 1.5
			//$filter_state		= $mainframe->getUserStateFromRequest( $option.'filter_state',		'filter_state',		'',				'word' );
			$filter_order		= $mainframe->getUserStateFromRequest( $option.'filter_order',		'filter_order',		'd.name',		'cmd' );
			$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'filter_order_Dir',	'filter_order_Dir',	'',				'word' );
			$search				= $mainframe->getUserStateFromRequest( $option.'search',			'search',			'',				'string' );
		}else{
			//Code pour Joomla >= 1.6.0
			$app = JFactory::getApplication();
			//$filter_state		= $app->getUserStateFromRequest( $option.'filter_state',		'filter_state',		'',				'word' );
			$filter_order		= $app->getUserStateFromRequest( $option.'filter_order',		'filter_order',		'd.name',		'cmd' );
			$filter_order_Dir	= $app->getUserStateFromRequest( $option.'filter_order_Dir',	'filter_order_Dir',	'',				'word' );
			$search				= $app->getUserStateFromRequest( $option.'search',			'search',			'',				'string' );
		}
		$search				= JString::strtolower( $search );
		
		// state filter
		//$lists['state']	= JHTML::_('grid.state',  $filter_state );
		
		// table ordering
		$lists['order_Dir'] = $filter_order_Dir;
		$lists['order'] = $filter_order;
		
		// search filter
		$lists['search']= $search;
		
        // push data into the template
        $this->assignRef('items', $items);     
        $this->assignRef('lists', $lists);
		$this->assignRef('pagination', $pagination);
		
		parent::display($tpl);
	}
}

}else{
//Code pour Joomla >= 1.6.0

/**
 * HTML Defined View class for the Collector component
 *
 * @package	Collector
 */
class CollectorViewDefined extends JView
{
	/**
	 * Display function
	 */
	function display($tpl = null)
	{
		$app = JFactory::getApplication();
		$app->redirect( 'index.php?option=com_collector&view=lists' );
	}
}

}
?>