<?php
/**
 * Joomla! 1.5 component Collector
 *
 * @version 	$Id: view.html.php 120 2011-09-04 22:33:31Z steevo $
 * @author 		Philippe Ousset steevo@steevo.fr
 * @package 	Collector
 * @license 	GNU/GPL
 *
 * Collector is a Multi Purpose Listing Tool.
 * Originaly developped to list Collections
 * it can be used for several purpose.
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.application.component.view');

/**
 * HTML Definededit View class for the Collector component
 *
 * @package	Collector
 */
class CollectorsViewDefinededit extends JView
{
	/**
	 * Display function
	 */
	function display($tpl = null)
	{
		global $mainframe;
		
		// Load pane behavior
		jimport('joomla.html.pane');
		
		$editor =& JFactory::getEditor();
		$pane =& JPane::getInstance('sliders');
		$user =& JFactory::getUser();
		$db =& JFactory::getDBO();
		$nulldate = $db->getNullDate();
		$datenow =& JFactory::getDate();
		
		$edit = JRequest::getBool( 'edit' );
		
		if ( $edit )
		{
			$cid = JRequest::getVar( 'cid', array(0), '', 'array' );
			
			JArrayHelper::toInteger($cid, array(0));
			$id = JRequest::getVar('id', $cid[0], '', 'int' );
		}
		else
		{
			$id = '';
		}
		
		$isNew = (empty($id));
		
		$option = JRequest::getCmd( 'option' );
		
		// Create and load the content table row
		$row = & JTable::getInstance('collector_defined','Table');
		
		$row->created = $nulldate;
		
		if ( !$isNew )
		{
			$row->load($id);
			
			/*if ( $row->state == -1 )
			{
				$mainframe->redirect( 'index.php?option=com_collector&view=defined' , JText::_( 'COM_COLLECTOR_NO_EDIT_COL_ARCHIVED' ) );
			}
			else
			{*/
				if ( $row->isCheckedOut($user->get('id'),$row->checked_out) )
				{
					$msg = JText::sprintf('COM_COLLECTOR_DESCBEINGEDITTED', JText::_('COM_COLLECTOR_THE_ITEM'), $row->name);
					$mainframe->redirect('index.php?option=com_collector&view=defined', $msg);
				}
			//}
			$row->checkout($user->get('id'));
			
		}
		
		// Create the Form
		$form = new JParameter('', JPATH_COMPONENT.DS.'params'.DS.'defined.xml');
		
		// Details Group
		$active = $isNew ? $user->get('id') : intval($row->created_by) ;
		$form->set('created_by', $active);
		$form->set('created_by_alias', $row->created_by_alias);
		$form->set('access', $row->access);
		$form->set('created', JHTML::_( 'date', $row->created, '%Y-%m-%d %H:%M:%S'));
		
		if ( $row->created == $nulldate )
		{
			$form->set('created', JHTML::_( 'date', $datenow->toMysql(), '%Y-%m-%d %H:%M:%S'));
		}
		else
		{
			$form->set('created', JHTML::_( 'date', $row->created, '%Y-%m-%d %H:%M:%S'));
		}
		
		/* if ( JHTML::_('date', $row->publish_up, '%Y') <= 1969 || $row->publish_up == $nulldate )
		{
			$form->set('publish_up', JText::_( 'COM_COLLECTOR_ALWAYS' ));
		}
		else
		{
			$form->set('publish_up', JHTML::_( 'date', $row->publish_up, '%Y-%m-%d %H:%M:%S'));
		}
		if ( JHTML::_('date', $row->publish_down, '%Y') <= 1969 || $row->publish_down == $nulldate )
		{
			$form->set('publish_down', JText::_('COM_COLLECTOR_NEVER'));
		}
		else
		{
			$form->set('publish_down', JHTML::_( 'date', $row->publish_down, '%Y-%m-%d %H:%M:%S'));
		} */
		
		if ( $row->width == '0' )
		{
			$form->set('width', '');
		}
		else
		{
			$form->set('width', $row->width);
		}
		if ( $row->width == '0' )
		{
			$form->set('height', '');
		}
		else
		{
			$form->set('height', $row->height);
		}
		
		$title = $isNew ? JText::_( 'COM_COLLECTOR_LISTS_MANAGER' )  . ': <small><small>[ '. JText::_( 'COM_COLLECTOR_NEW' ) .' ]</small></small>' : JText::_( 'COM_COLLECTOR_LISTS_MANAGER' )  . ': <small><small>[ '. JText::_( 'COM_COLLECTOR_EDIT' ) .' ]</small></small>' ;
		JToolBarHelper::title( $title , 'sections' );
		
		JToolBarHelper::save();
		JToolBarHelper::apply();
		if ($isNew)
		{
			JToolBarHelper::cancel();
		}
		else
		{
			// for existing items the button is renamed 'close'
			JToolBarHelper::cancel( 'cancel' , 'Close' );
		}
		
		//Check for database error
		if (!$db->query())
		{
			return JError::raiseWarning( 500, $db->getErrorMsg() );
		}
		
		$this->assignRef( 'row', $row );
		$this->assignRef( 'pane', $pane );
		$this->assignRef( 'editor', $editor );
		$this->assignRef( 'form', $form );
		
		parent::display($tpl);
	}
	
	/**
	 * Method to display defined list informations
	 *
	 * @access	public
	 * @param	string	$row	Defined list to display
	 * @return	void
	 */
	function displayFieldInformations(&$row)
	{
		$db =& JFactory::getDBO();
		$nulldate = $db->getNullDate();
		
		?>
		<table width="100%" style="border: 1px dashed silver; padding: 5px; margin-bottom: 10px;">
		<?php
		if ($row->id)
		{
		?>
		<tr>
			<td>
				<strong><?php echo JText::_( 'COM_COLLECTOR_ARTICLE_ID' ); ?>:</strong>
			</td>
			<td>
				<?php echo $row->id; ?>
			</td>
		</tr>
		<?php
		}
		?>
		<!-- <tr>
			<td>
				<strong><?php //echo JText::_( 'COM_COLLECTOR_STATE' ); ?></strong>
			</td>
			<td>
				<?php //echo $row->state > 0 ? JText::_( 'COM_COLLECTOR_PUBLISHED' ) : ( $row->state < 0 ? JText::_( 'COM_COLLECTOR_ARCHIVED' ) : JText::_( 'COM_COLLECTOR_DRAFT_UNPUBLISHED' ) );?>
			</td>
		</tr> -->
		<tr>
			<td>
				<strong><?php echo JText::_( 'COM_COLLECTOR_CREATED' ); ?></strong>
			</td>
			<td>
				<?php
				if ( $row->created == $nulldate )
				{
					echo JText::_( 'COM_COLLECTOR_NEW_DOCUMENT' );
				}
				else
				{
					echo JHTML::_( 'date', $row->created, JText::_( 'DATE_FORMAT_LC2') );
				}
				?>
			</td>
		</tr>
		<tr>
			<td>
				<strong><?php echo JText::_( 'COM_COLLECTOR_MODIFIED' ); ?></strong>
			</td>
			<td>
				<?php
				if ( $row->modified == $nulldate )
				{
					echo JText::_( 'COM_COLLECTOR_NOT_MODIFIED' );
				}
				else
				{
					echo JHTML::_('date', $row->modified, JText::_( 'DATE_FORMAT_LC2' ));
				}
				?>
			</td>
		</tr>
		</table>
		<?php
	}
	
}
?>