<?php
/**
 * Joomla! 1.5 component Collector
 *
 * @version 	$Id: view.html.php 128 2012-01-24 23:17:19Z steevo $
 * @author 		Philippe Ousset steevo@steevo.fr
 * @package 	Collector
 * @license 	GNU/GPL
 *
 * Collector is a Multi Purpose Listing Tool.
 * Originaly developped to list Collections
 * it can be used for several purpose.
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.application.component.view');

/**
 * HTML Fieldedit View class for the Collector component
 *
 * @package	Collector
 */
class CollectorsViewFieldedit extends JView
{
	/**
	 * Display function
	 */
	function display($tpl = null)
	{
		global $mainframe;
		
		// Load pane behavior
		jimport('joomla.html.pane');
		
		$editor =& JFactory::getEditor();
		$pane =& JPane::getInstance('sliders');
		$user =& JFactory::getUser();
		$db =& JFactory::getDBO();
		$nulldate = $db->getNullDate();
		$datenow =& JFactory::getDate();
		
		$collection = JRequest::getVar( 'collection', '', '', 'int');
		
		$edit = JRequest::getBool( 'edit' );
		
		if ( $edit )
		{
			$cid = JRequest::getVar( 'cid', array(0), '', 'array' );
			
			JArrayHelper::toInteger($cid, array(0));
			$id = JRequest::getVar('id', $cid[0], '', 'int' );
		}
		else
		{
			$id = '';
		}
		
		$isNew = (empty($id));
		
		$option = JRequest::getCmd( 'option' );
		
		// Create and load the content table row
		$row = & JTable::getInstance('collector_fields','Table');
		
		$row->created = $nulldate;
		
		$row->ordering = $row->getNextOrder('collection='.$collection);
		
		if ( !$isNew )
		{
			$row->load($id);
			
			if ( $row->state == -1 )
			{
				$mainframe->redirect( 'index.php?option=com_collector&view=collections' , JText::_( 'COM_COLLECTOR_NO_EDIT_COL_ARCHIVED' ) );
			}
			else
			{
				if ( $row->isCheckedOut($user->get('id'),$row->checked_out) )
				{
					$msg = JText::sprintf('COM_COLLECTOR_DESCBEINGEDITTED', JText::_('COM_COLLECTOR_THE_ITEM'), $row->name);
					$mainframe->redirect('index.php?option=com_collector&view=collectionfield$collection='.$row->collection, $msg);
				}
			}
			$row->checkout($user->get('id'));
			
		}
		
		// Create the Form
		$form = new JParameter('', JPATH_COMPONENT.DS.'params'.DS.'field.xml');
		
		// Details Group
		$active = $isNew ? $user->get('id') : intval($row->created_by) ;
		$form->set('created_by', $active);
		$form->set('created_by_alias', $row->created_by_alias);
		$form->set('access', $row->access);
		$form->set('created', JHTML::_( 'date', $row->created, '%Y-%m-%d %H:%M:%S'));
		
		if ( $row->created == $nulldate )
		{
			$form->set('created', JHTML::_( 'date', $datenow->toMysql(), '%Y-%m-%d %H:%M:%S'));
		}
		else
		{
			$form->set('created', JHTML::_( 'date', $row->created, '%Y-%m-%d %H:%M:%S'));
		}
		
		if ( JHTML::_('date', $row->publish_up, '%Y') <= 1969 || $row->publish_up == $nulldate )
		{
			$form->set('publish_up', JText::_( 'COM_COLLECTOR_ALWAYS' ));
		}
		else
		{
			$form->set('publish_up', JHTML::_( 'date', $row->publish_up, '%Y-%m-%d %H:%M:%S'));
		}
		if ( JHTML::_('date', $row->publish_down, '%Y') <= 1969 || $row->publish_down == $nulldate )
		{
			$form->set('publish_down', JText::_('COM_COLLECTOR_NEVER'));
		}
		else
		{
			$form->set('publish_down', JHTML::_( 'date', $row->publish_down, '%Y-%m-%d %H:%M:%S'));
		}
		
		$title = $isNew ? JText::_( 'COM_COLLECTOR_FIELDS_MANAGER' )  . ': <small><small>[ '. JText::_( 'COM_COLLECTOR_NEW' ) .' ]</small></small>' : JText::_( 'COM_COLLECTOR_FIELDS_MANAGER' )  . ': <small><small>[ '. JText::_( 'COM_COLLECTOR_EDIT' ) .' ]</small></small>' ;
		JToolBarHelper::title( $title , 'menumgr' );
		
		JToolBarHelper::save();
		JToolBarHelper::apply();
		if ($isNew)
		{
			JToolBarHelper::cancel();
		}
		else
		{
			// for existing items the button is renamed 'close'
			JToolBarHelper::cancel( 'cancel' , 'Close' );
		}
		
		$init[] = array('value' => 0, 'text' => '');
		
		// Get list of field types
		$db =& JFactory::getDBO(); 
		$query = 'SELECT id AS value, type AS text ';
		$query .= ' FROM #__collector_fields_type';
		$db->setQuery( $query );
		$results = $db->loadObjectList();
		//Check for database error
		if (!$db->query())
		{
			return JError::raiseWarning( 500, $db->getErrorMsg() );
		}
		
		$select = $init;
		foreach ( $results as $key => $value )
		{
			$value->text=JText::_('COM_COLLECTOR_'.$value->text);
			$select[$key+1]=$value;
		}
		
		$lists['type'] = JHTML::_('select.genericlist', $select, 'type', ' class=inputbox size="1" ', 'value', 'text', $row->type);
		
		if ( $row->type == 3 )
		{
			// Get list of clients for dropdown
			$db =& JFactory::getDBO(); 
			$query = 'SELECT id AS value, name AS text ';
			$query .= ' FROM #__collector_defined';
			$db->setQuery( $query );
			
			$results = $db->loadObjectList();
			
			//Check for database error
			if (!$db->query())
			{
				return JError::raiseWarning( 500, $db->getErrorMsg() );
			}
			
			$select = $init;
			foreach ( $results as $key => $value )
			{
				$select[$key+1]=$value;
			}
			
			$lists['defined'] = JHTML::_('select.genericlist', $select, 'defined', ' class=inputbox size="1" ', 'value', 'text', $row->defined);
		}
		else if ( $row->type == 4 )
		{
			// Get list of collections
			$db =& JFactory::getDBO(); 
			$query = 'SELECT id AS value, name AS text ';
			$query .= ' FROM #__collector';
			$db->setQuery( $query );
			
			$results = $db->loadObjectList();
			
			//Check for database error
			if (!$db->query())
			{
				return JError::raiseWarning( 500, $db->getErrorMsg() );
			}
			
			$select = $init;
			foreach ( $results as $key => $value )
			{
				$select[$key+1]=$value;
			}
			
			$lists['defined'] = JHTML::_('select.genericlist', $select, 'collection', ' class=inputbox size="1" ', 'value', 'text', $row->defined);
		}
		else
		{
			$lists['defined'] = '<input type="hidden" name="defined" value="0" />';
		}
		
		JHTML::_('behavior.tooltip');
		
		$this->assignRef( 'row', $row );
		$this->assignRef( 'pane', $pane );
		$this->assignRef( 'collection', $collection );
		$this->assignRef( 'editor', $editor );
		$this->assignRef( 'lists', $lists );
		$this->assignRef( 'form', $form );
		
		parent::display($tpl);
	}
	
	/**
	 * Method to display field informations
	 *
	 * @access	public
	 * @param	string	$row	Field to display
	 * @return	void
	 */
	function displayFieldInformations(&$row)
	{
		$db =& JFactory::getDBO();
		$nulldate = $db->getNullDate();
		
		?>
		<table width="100%" style="border: 1px dashed silver; padding: 5px; margin-bottom: 10px;">
		<?php
		if ($row->id)
		{
		?>
		<tr>
			<td>
				<strong><?php echo JText::_( 'COM_COLLECTOR_FIELD_ID' ); ?>:</strong>
			</td>
			<td>
				<?php echo $row->id; ?>
			</td>
		</tr>
		<?php
		}
		?>
		<tr>
			<td>
				<strong><?php echo JText::_( 'COM_COLLECTOR_STATE' ); ?></strong>
			</td>
			<td>
				<?php echo $row->state > 0 ? JText::_( 'COM_COLLECTOR_PUBLISHED' ) : ( $row->state < 0 ? JText::_( 'COM_COLLECTOR_ARCHIVED' ) : JText::_( 'COM_COLLECTOR_DRAFT_UNPUBLISHED' ) );?>
			</td>
		</tr>
		<tr>
			<td>
				<strong><?php echo JText::_( 'COM_COLLECTOR_CREATED' ); ?></strong>
			</td>
			<td>
				<?php
				if ( $row->created == $nulldate )
				{
					echo JText::_( 'COM_COLLECTOR_NEW_DOCUMENT' );
				}
				else
				{
					echo JHTML::_( 'date', $row->created, JText::_( 'DATE_FORMAT_LC2') );
				}
				?>
			</td>
		</tr>
		<tr>
			<td>
				<strong><?php echo JText::_( 'COM_COLLECTOR_MODIFIED' ); ?></strong>
			</td>
			<td>
				<?php
				if ( $row->modified == $nulldate )
				{
					echo JText::_( 'COM_COLLECTOR_NOT_MODIFIED' );
				}
				else
				{
					echo JHTML::_('date', $row->modified, JText::_( 'DATE_FORMAT_LC2' ));
				}
				?>
			</td>
		</tr>
		</table>
		<?php
	}
	
}
?>