<?php
/**
 * Joomla! 1.5 component Collector
 *
 * @version 	$Id: view.html.php 122 2011-09-13 22:26:20Z steevo $
 * @author 		Philippe Ousset steevo@steevo.fr
 * @package 	Collector
 * @license 	GNU/GPL
 *
 * Collector is a Multi Purpose Listing Tool.
 * Originaly developped to list Collections
 * it can be used for several purpose.
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.application.component.view');

if(version_compare(JVERSION,'1.6.0','<')){
//Code pour Joomla! 1.5

/**
 * HTML Folderselect View class for the Collector component
 *
 * @package	Collector
 */
class CollectorsViewFolderselect extends JView
{
	/**
	 * Display function
	 */
	function display($tpl = null)
	{
		global $mainframe;
		
		$user =& JFactory::getUser();
		if (!$user->authorize('com_collector', 'filemanage')) {
			//Get a handle to the Joomla! application object
			$app =& JFactory::getApplication(); 
			//add a message to the message queue
			$app->enqueueMessage( JText::_( 'COM_COLLECTOR_SUPERADMIN_ONLY' ), 'error' );
		} else {
			
			// Get data from the model
			$model =& $this->getModel('folderselect');
			$lists =& $model->getList();
			$task =& $model->getTask();
			$folder =& $model->getFolder();
			$elements =& $model->getElements();
			$navigation =& $model->get_path_navigation();
			
			$this->assignRef( 'task', $task );
			$this->assignRef( 'folder', $folder );
			$this->assignRef( 'elements', $elements );
			$this->assignRef( 'lists', $lists );
			$this->assignRef( 'navigation', $navigation );
			
			parent::display($tpl);
		}
	}
}

}else{
//Code pour Joomla >= 1.6.0
/**
 * HTML Folderselect View class for the Collector component
 *
 * @package	Collector
 */
class CollectorViewFolderselect extends JView
{
	/**
	 * Display function
	 */
	function display($tpl = null)
	{
		$user =& JFactory::getUser();
		if (!$user->authorize('com_collector', 'filemanage')) {
			//Get a handle to the Joomla! application object
			$app =& JFactory::getApplication(); 
			//add a message to the message queue
			$app->enqueueMessage( JText::_( 'COM_COLLECTOR_SUPERADMIN_ONLY' ), 'error' );
		} else {
			
			// Get data from the model
			$model =& $this->getModel('folderselect');
			$lists =& $model->getList();
			$task =& $model->getTask();
			$folder =& $model->getFolder();
			$elements =& $model->getElements();
			$navigation =& $model->get_path_navigation();
			
			$this->assignRef( 'task', $task );
			$this->assignRef( 'folder', $folder );
			$this->assignRef( 'elements', $elements );
			$this->assignRef( 'lists', $lists );
			$this->assignRef( 'navigation', $navigation );
			
			parent::display($tpl);
		}
	}
}

}
?>