<?php
/**
 * Joomla! 1.5 component Collector
 *
 * @version 	$Id: view.html.php 120 2011-09-04 22:33:31Z steevo $
 * @author 		Philippe Ousset steevo@steevo.fr
 * @package 	Collector
 * @license 	GNU/GPL
 *
 * Collector is a Multi Purpose Listing Tool.
 * Originaly developped to list Collections
 * it can be used for several purpose.
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.application.component.view');

/**
 * HTML Htmledit View class for the Collector component
 *
 * @package	Collector
 */
class CollectorsViewHtmledit extends JView
{
	/**
	 * Display function
	 */
	function display($tpl = null)
	{
		global $mainframe;
		
		$cid = JRequest::getVar( 'cid', array(0), '', 'array' );
			
		JArrayHelper::toInteger($cid, array(0));
		$id = JRequest::getVar('id', $cid[0], '', 'int' );
		
		// Create and load the content table row
		JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_collector'.DS.'tables');
		$row = & JTable::getInstance('collector_templates','Table');
		
		if (!empty($id))
		{
			$row->load($id);
			
			if ( $row->alias == 'default' )
			{
				$msg = JText::_( 'COM_COLLECTOR_NO_EDIT_DEFAULT_TPL' );
				$mainframe->redirect('index.php?option=com_collector&view=templates', $msg );
			}
			
			if ($row->client == 1)
			{
				$client = 'collection';
			}
			else
			{
				$client = 'item';
			}
			
			$file = JPATH_SITE.DS.'components'.DS.'com_collector'.DS.'views'.DS.$client.DS.'tmpl'.DS.'default_'.$row->alias.'.php';
		}
		
		// Read the source file
		jimport('joomla.filesystem.file');
		$content = JFile::read($file);

		if ($content !== false)
		{
			$content = htmlspecialchars($content, ENT_COMPAT, 'UTF-8');
		} else {
			$msg = JText::sprintf('COM_COLLECTOR_OPERATION_FAILED_COULD_NOT_OPEN', $file);
			$mainframe->redirect('index.php?option=com_collector&view=templates', $msg);
		}
		
		$title = JText::_( 'COM_COLLECTOR_TEMPLATES_MANAGER' ) . ': <small><small>[ '. JText::_( 'COM_COLLECTOR_EDIT' ) .' ]</small></small>' ;
		JToolBarHelper::title( $title , 'thememanager' );
		
		JToolBarHelper::save( 'save_source' );
		JToolBarHelper::cancel( 'cancel' , 'Close' );
		
		JHTML::_('behavior.tooltip');
		
		$this->assignRef( 'row', $row );
		$this->assignRef( 'file', $file );
		$this->assignRef( 'content', $content );
		
		parent::display($tpl);
	}
}
?>