<?php
/**
 * Joomla! 1.5 component Collector
 *
 * @version 	$Id: view.html.php 127 2011-12-10 22:51:55Z steevo $
 * @author 		Philippe Ousset steevo@steevo.fr
 * @package 	Collector
 * @license 	GNU/GPL
 *
 * Collector is a Multi Purpose Listing Tool.
 * Originaly developped to list Collections
 * it can be used for several purpose.
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.application.component.view');

/**
 * HTML Itemedit View class for the Collector component
 *
 * @package	Collector
 */
class CollectorsViewItemedit extends JView
{
	/**
	 * Display function
	 */
	function display($tpl = null)
	{
		global $mainframe;
		
		// Load pane behavior
		jimport('joomla.html.pane');
		
		$editor =& JFactory::getEditor();
		$pane =& JPane::getInstance('sliders');
		$user =& JFactory::getUser();
		$db =& JFactory::getDBO();
		$nulldate = $db->getNullDate();
		$datenow =& JFactory::getDate();
		$params =& JComponentHelper::getParams( 'com_collector' );
		
		$collection = JRequest::getVar( 'collection', '', '', 'int');
		
		$model = $this->getModel('itemedit');
		
		$task = JRequest::getCmd('task');
		
		$option = JRequest::getCmd( 'option' );
		
		// Create and load the content table row
		$row = & JTable::getInstance('collector_items','Table');
		//$row->initVersion($collection);
		
		$query = 'SELECT id, field, tablecolumn, type, defined, template';
		$query .= ' FROM `#__collector_fields`';
		$query .= ' WHERE collection = "' . $collection . '"';
		$query .= ' ORDER BY ordering';
		
		$db->setQuery($query);
		
		$fields = $db->loadObjectList();
		
		switch ($task) {
			case 'edit':
				$cid = JRequest::getVar( 'cid', array(0), '', 'array' );
				
				JArrayHelper::toInteger($cid, array(0));
				$id = JRequest::getVar('id', $cid[0], '', 'int' );
				
				$row->loadVersion( $collection, $id );
				
				if ( $row->state == -1 )
				{
					$mainframe->redirect( 'index.php?option=com_collector&view=items' , JText::_( 'COM_COLLECTOR_NO_EDIT_ITEM_ARCHIVED' ) );
				}
				else
				{
					if ( $row->isCheckedOut($user->get('id'),$row->checked_out) )
					{
						$msg = JText::sprintf('COM_COLLECTOR_DESCBEINGEDITTED', JText::_('COM_COLLECTOR_THE_ITEM'), $row->name);
						$mainframe->redirect('index.php?option=com_collector&view=items', $msg);
					}
				}
				$row->checkout($user->get('id'));
				$row->history->modification = null;
				break;
				
			case 'duplicate':
				$cid = JRequest::getVar( 'cid', array(0), '', 'array' );
				
				JArrayHelper::toInteger($cid, array(0));
				$id = JRequest::getVar('id', $cid[0], '', 'int' );
				
				$row->loadCopyVersion( $collection, $id );
				break;
				
			case 'add':
				$row->initVersion($collection);
				break;
		}
		
		// Create the Form
		$form = new JParameter('', JPATH_COMPONENT.DS.'params'.DS.'item.xml');
		
		// Details Group
		$active = !($task=='edit') ? $user->get('id') : intval($row->created_by) ;
		$form->set('created_by', $active);
		$form->set('created_by_alias', $row->created_by_alias);
		$form->set('access', $row->access);
		$form->set('created', JHTML::_( 'date', $row->created, '%Y-%m-%d %H:%M:%S'));
		
		if ( $row->created == $nulldate )
		{
			$form->set('created', JHTML::_( 'date', $datenow->toMysql(), '%Y-%m-%d %H:%M:%S'));
		}
		else
		{
			$form->set('created', JHTML::_( 'date', $row->created, '%Y-%m-%d %H:%M:%S'));
		}
		
		if ( JHTML::_('date', $row->publish_up, '%Y') <= 1969 || $row->publish_up == $nulldate )
		{
			$form->set('publish_up', JText::_( 'COM_COLLECTOR_ALWAYS' ));
		}
		else
		{
			$form->set('publish_up', JHTML::_( 'date', $row->publish_up, '%Y-%m-%d %H:%M:%S'));
		}
		if ( JHTML::_('date', $row->publish_down, '%Y') <= 1969 || $row->publish_down == $nulldate )
		{
			$form->set('publish_down', JText::_('COM_COLLECTOR_NEVER'));
		}
		else
		{
			$form->set('publish_down', JHTML::_( 'date', $row->publish_down, '%Y-%m-%d %H:%M:%S'));
		}
		
		$form->set('description', $row->history->metadesc);
		$form->set('keywords', $row->history->metakey);
		$form->loadINI($row->history->metadata);
		
		$title = !($task=='edit') ? JText::_( 'COM_COLLECTOR_ITEMS_MANAGER' ) . ': <small><small>[ '. JText::_( 'COM_COLLECTOR_NEW' ) .' ]</small></small>' : JText::_( 'COM_COLLECTOR_ITEMS_MANAGER' ) . ': <small><small>[ '. JText::_( 'COM_COLLECTOR_EDIT' ) .' ]</small></small>' ;
		JToolBarHelper::title( $title , 'addedit' );
		
		JToolBarHelper::save();
		JToolBarHelper::apply();
		if (!($task=='edit'))
		{
			JToolBarHelper::cancel();
		}
		else
		{
			// for existing items the button is renamed 'close'
			JToolBarHelper::cancel( 'cancel' , 'Close' );
		}
		
		$folder = $model->getFolder();
		
		// Get list of collections
		$db =& JFactory::getDBO(); 
		$query = 'SELECT id AS value, name AS text ';
		$query .= ' FROM #__collector';
		$db->setQuery( $query );
		
		$results = $db->loadObjectList();
		
		//Check for database error
		if (!$db->query())
		{
			return JError::raiseWarning( 500, $db->getErrorMsg() );
		}
		
		$lists['collections'] = JHTML::_('select.genericlist', $results, 'collection', ' class=inputbox size="1" disabled', 'value', 'text', $collection);
		
		JHTML::_('behavior.tooltip');
		JHTML::_('behavior.modal');
		
		$this->assignRef( 'folder', $folder );
		$this->assignRef( 'row', $row );
		$this->assignRef( 'collection', $collection );
		$this->assignRef( 'fields', $fields );
		$this->assignRef( 'lists', $lists );
		$this->assignRef( 'pane', $pane );
		$this->assignRef( 'editor', $editor );
		$this->assignRef( 'form', $form );
		$this->assignRef( 'params', $params );
		
		parent::display($tpl);
	}
	
	/**
	 * Method to display field edition
	 *
	 * @access	public
	 * @param	string	$row	Field to display
	 * @return	void
	 */
	function createField( $field )
	{
		$task = JRequest::getCmd('task');
		
		$model = $this->getModel('itemedit');
		
		//$folder = $model->getFolder();
		
		$type = $field->type;
		
		//$name_field = 'field_' . $field->id;
		$name_field = $field->tablecolumn;
		
		$init[] = array('value' => 0, 'text' => '---');
		
		// champ simple ligne
		if ( $type == '1' )
		{
			return "<input name=" . $name_field . " value='" . htmlspecialchars($this->row->history->$name_field, ENT_QUOTES) . "' size='60' maxlength='254' />";
		}
		// champ texte
		else if ( $type == '2' )
		{
			if ( $task == 'add' )
			{
				$value = $field->template;
			}
			else
			{
				$value = $this->row->history->$name_field;
			}
			return $this->editor->display($name_field, $value, '100%', '350', '75', '20' );
		}
		// champ predefini
		else if ( $type == '3' )
		{
			$db =& JFactory::getDBO();
			
			$query = 'SELECT id AS value, content AS text ';
			$query .= ' FROM #__collector_defined_content';
			$query .= ' WHERE defined = ' . $field->defined;
			$query .= ' ORDER BY text';
			
			$db->setQuery( $query );
			
			$results = $db->loadObjectList();
			
			$select = $init;
			
			foreach ( $results as $key => $value )
			{
				$select[$key+1]=$value;
			}
				
			return JHTML::_('select.genericlist', $select, $name_field, ' class="inputbox" size="1" ', 'value', 'text', $this->row->history->$name_field);
		}
		// champ objet
		else if ( $type == '4' )
		{
			$items = $model->getItemsList($field);
			
			$select = $init;
			
			foreach ( $items as $key => $value )
			{
				$select[$key+1]=$value;
			}
				
			return JHTML::_('select.genericlist', $select, $name_field, ' class=inputbox size="1" ', 'value', 'text', $this->row->history->$name_field);
		}
		// champ image
		else if ( $type == '5' )
		{
			$imageInfos = explode('|',$this->row->history->$name_field);
			
			$input = '<input type="text" onchange="setImage(\''.$name_field.'\',\'0\');" name="' . $name_field . '" id="' . $name_field . '" value="' . htmlspecialchars($this->row->history->$name_field, ENT_QUOTES) . '" size="60" maxlength="254" />';
			
			if ( $imageInfos[0] == '' )
			{
				$folder = $this->folder;
			}
			else
			{
				$path = explode('/',$imageInfos[0]);
				unset($path[sizeof($path)-1]);
				$folder = implode('/',$path);
			}
			$link = JRoute::_('index.php?option=com_collector&amp;view=fileselect&amp;tmpl=component&amp;folder='.$folder.'&amp;field='.$name_field.'&amp;type=1');
			return $input.'</td><td><div class="button2-left"><div class="image"><a class="modal" rel="{handler: \'iframe\', size: {x: 550, y: 515}}" href="'.$link.'">'. JText::_('COM_COLLECTOR_SELECT_IMAGE') . '</a></div></div></td></tr><tr><td></td><td colspan=2><img src="'.JURI::root().$imageInfos[0].'" alt="'.$imageInfos[1].'" name="'.$name_field.'-preview" id="'.$name_field.'-preview" />';
		}
		// champ nombre
		else if ( $type == '6' )
		{
			$template = $field->template == '' ? '%%' : $field->template;
			$input = "<input name=" . $name_field . " value='" . htmlspecialchars($this->row->history->$name_field, ENT_QUOTES) . "' size='60' maxlength='254' />";
			$return = JString::str_ireplace( '%%', $input, $template );
			return $return;
		}
		// champ date
		else if ( $type == '7' )
		{
			return JHTML::_('calendar', $this->row->history->$name_field, $name_field, $name_field, '%Y-%m-%d %H:%M:%S');
		}
		// champ fichier
		else if ( $type == '8' )
		{
			$fileInfos = explode('|',$this->row->history->$name_field);
			
			$input = '<input type="text" name="' . $name_field . '" id="' . $name_field . '" value="' . htmlspecialchars($this->row->history->$name_field, ENT_QUOTES) . '" size="60" maxlength="254" />';
			
			if ( $fileInfos[0] == '' )
			{
				$folder = $this->folder;
			}
			else
			{
				$path = explode('/',$fileInfos[0]);
				unset($path[sizeof($path)-1]);
				$folder = implode('/',$path);
			}
			
			$link = JRoute::_('index.php?option=com_collector&amp;view=fileselect&amp;tmpl=component&amp;folder='.$folder.'&amp;field='.$name_field.'&amp;type=0');
			return $input.'</td><td><div class="button2-left"><div class="image"><a class="modal" rel="{handler: \'iframe\', size: {x: 550, y: 515}}" href="'.$link.'">'. JText::_('COM_COLLECTOR_FILE_SELECT') . '</a></div></div></td>';
		}
		else
		{
			return JText::_( 'COM_COLLECTOR_NO_FIELD_CREATED' );
		}
	}
	
	/**
	 * Method to display item informations
	 *
	 * @access	public
	 * @param	string	$row	Item to display
	 * @return	void
	 */
	function displayItemInformations(&$row)
	{
		$db =& JFactory::getDBO();
		$nulldate = $db->getNullDate();
		
		// used to hide "Reset Hits" when hits = 0
		if ( !$row->hits ) {
			$visibility = 'style="display: none; visibility: hidden;"';
		} else {
			$visibility = '';
		}
		
		?>
		<table width="100%" style="border: 1px dashed silver; padding: 5px; margin-bottom: 10px;">
		<?php
		if ($row->id)
		{
		?>
		<tr>
			<td>
				<strong><?php echo JText::_( 'COM_COLLECTOR_ITEM_ID' ); ?>:</strong>
			</td>
			<td>
				<?php echo $row->id; ?>
			</td>
		</tr>
		<?php
		}
		?>
		<tr>
			<td>
				<strong><?php echo JText::_( 'COM_COLLECTOR_STATE' ); ?></strong>
			</td>
			<td>
				<?php echo $row->state > 0 ? JText::_( 'COM_COLLECTOR_PUBLISHED' ) : ( $row->state < 0 ? JText::_( 'COM_COLLECTOR_ARCHIVED' ) : JText::_( 'COM_COLLECTOR_DRAFT_UNPUBLISHED' ) );?>
			</td>
		</tr>
		<tr>
			<td>
				<strong><?php echo JText::_( 'COM_COLLECTOR_CREATED' ); ?></strong>
			</td>
			<td>
				<?php
				if ( $row->created == $nulldate )
				{
					echo JText::_( 'COM_COLLECTOR_NEW_DOCUMENT' );
				}
				else
				{
					echo JHTML::_( 'date', $row->created, JText::_( 'DATE_FORMAT_LC2') );
				}
				?>
			</td>
		</tr>
		<tr>
			<td>
				<strong><?php echo JText::_( 'COM_COLLECTOR_MODIFIED' ); ?></strong>
			</td>
			<td>
				<?php
				if ( $row->modified == $nulldate )
				{
					echo JText::_( 'COM_COLLECTOR_NOT_MODIFIED' );
				}
				else
				{
					echo JHTML::_('date', $row->modified, JText::_( 'DATE_FORMAT_LC2' ));
				}
				?>
			</td>
		</tr>
		<tr>
			<td>
				<strong><?php echo JText::_( 'COM_COLLECTOR_HITS' ); ?></strong>
			</td>
			<td>
				<?php echo $row->hits;?>
				<span <?php echo $visibility; ?>>
					<input name="reset_hits" type="button" class="button" value="<?php echo JText::_( 'COM_COLLECTOR_RESET' ); ?>" onclick="submitbutton('resethits');" />
				</span>
			</td>
		</tr>
		</table>
		<?php
	}
	
}
?>