<?php
/**
 * Joomla! 1.5 component Collector
 *
 * @version 	$Id: view.html.php 128 2012-01-24 23:17:19Z steevo $
 * @author 		Philippe Ousset steevo@steevo.fr
 * @package 	Collector
 * @license 	GNU/GPL
 *
 * Collector is a Multi Purpose Listing Tool.
 * Originaly developped to list Collections
 * it can be used for several purpose.
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.application.component.view');

if(version_compare(JVERSION,'1.6.0','<')){
//Code pour Joomla! 1.5

/**
 * HTML Templates View class for the Collector component
 *
 * @package	Collector
 */
class CollectorsViewTemplates extends JView
{
	/**
	 * Display function
	 */
	function display($tpl = null)
	{
		global $mainframe, $option;
		
		$user =& JFactory::getUser();
		
		JToolBarHelper::title( JText::_( 'COM_COLLECTOR_TEMPLATES_MANAGER' ), 'thememanager' );
		
		JToolBarHelper::makeDefault( 'setdefault' );
		JToolBarHelper::deleteList();
		JToolBarHelper::editListX();
		JToolBarHelper::customX( 'edit_source', 'html.png', 'html_f2.png', 'Edit HTML' );
		JToolBarHelper::customX( 'copy', 'copy.png', 'copy_f2.png', 'Copy' );
		JToolBarHelper::addNewX();
		
		JSubMenuHelper::addEntry( JText::_('COM_COLLECTOR_HOME'), 'index.php?option=com_collector');
		if ($user->authorize('com_collector', 'filemanage')) {
			JSubMenuHelper::addEntry( JText::_('COM_COLLECTOR_FILE_MANAGER'), 'index.php?option=com_collector&view=filemanager');
		}
		JSubMenuHelper::addEntry( JText::_('COM_COLLECTOR_COLLECTIONS'), 'index.php?option=com_collector&view=collections');
		JSubMenuHelper::addEntry( JText::_('COM_COLLECTOR_LISTS'), 'index.php?option=com_collector&view=defined');
		JSubMenuHelper::addEntry( JText::_('COM_COLLECTOR_FIELDS'), 'index.php?option=com_collector&view=collectionfields');
		JSubMenuHelper::addEntry( JText::_('COM_COLLECTOR_ITEMS'), 'index.php?option=com_collector&view=items');
		if ($user->authorize('com_collector', 'templatemanage')) {
			JSubMenuHelper::addEntry( JText::_('COM_COLLECTOR_TEMPLATES'), 'index.php?option=com_collector&view=templates', true);
		}
		
		JHTML::_('behavior.tooltip');
		
		if (!$user->authorize('com_collector', 'templatemanage')) {
			//Get a handle to the Joomla! application object
			$app =& JFactory::getApplication(); 
			//add a message to the message queue
			$app->enqueueMessage( JText::_( 'COM_COLLECTOR_SUPERADMIN_ONLY' ), 'error' );
		} else {
			$filter_client		= JRequest::getVar( 'filter_client', '', '', 'int');
			if(version_compare(JVERSION,'1.6.0','<')){
				//Code pour Joomla! 1.5
				$filter_order		= $mainframe->getUserStateFromRequest( $option.'filter_order',		'filter_order',		'name',			'cmd' );
				$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'filter_order_Dir',	'filter_order_Dir',	'',				'word' );
				$search				= $mainframe->getUserStateFromRequest( $option.'search',			'search',			'',				'string' );
			}else{
				//Code pour Joomla >= 1.6.0
				$app = JFactory::getApplication();
				$filter_order		= $app->getUserStateFromRequest( $option.'filter_order',		'filter_order',		'name',			'cmd' );
				$filter_order_Dir	= $app->getUserStateFromRequest( $option.'filter_order_Dir',	'filter_order_Dir',	'',				'word' );
				$search				= $app->getUserStateFromRequest( $option.'search',			'search',			'',				'string' );
			}
			$search				= JString::strtolower( $search );
			
			// Get data from the model
			$model =& $this->getModel('templates');
			$items =& $model->getData();
			$collection = $model->getCollection();
			$default = $model->checkHome($collection);
			
			$pagination =& $model->getPagination();
			
			// type filter
			$type[] = JHTML::_('select.option',  '', '- '. JText::_( 'COM_COLLECTOR_SELECT_TYPE' ) .' -' );
			$type[] = JHTML::_('select.option',  '1', JText::_( 'COM_COLLECTOR_LISTING' ) );
			$type[] = JHTML::_('select.option',  '2', JText::_( 'COM_COLLECTOR_DETAIL' ) );
			
			$lists['type'] = JHTML::_('select.genericlist',   $type, 'filter_client', 'class="inputbox" size="1" onchange="submitform( );"', 'value', 'text', $filter_client );
			
			// table ordering
			$lists['order_Dir'] = $filter_order_Dir;
			$lists['order'] = $filter_order;
			
			// search filter
			$lists['search']= $search;
			
			// Get list of collections
			$db =& JFactory::getDBO(); 
			$query = 'SELECT id AS value, name AS text ';
			$query .= ' FROM #__collector';
			$db->setQuery( $query );
			
			$results = $db->loadObjectList();
			
			//Check for database error
			if (!$db->query())
			{
				return JError::raiseWarning( 500, $db->getErrorMsg() );
			}
			
			$lists['collections'] = JHTML::_('select.genericlist', $results, 'collection', ' class=inputbox size="1" onchange="submitform( );"', 'value', 'text', $collection);
			
			$this->assignRef( 'items', $items );
			$this->assignRef( 'lists', $lists );
			$this->assignRef( 'default', $default );
			$this->assignRef( 'pagination', $pagination );
			
			parent::display($tpl);
		}
	}
}

}else{
//Code pour Joomla >= 1.6.0

/**
 * HTML Templates View class for the Collector component
 *
 * @package	Collector
 */
class CollectorViewTemplates extends JView
{
	/**
	 * Display the view
	 *
	 * @return	void
	 */
	public function display($tpl = null)
	{
		// We don't need toolbar in the modal window.
		if ($this->getLayout() !== 'modal') {
			$this->addToolbar();
		}
		
		$msg = JText::_( 'COM_COLLECTOR_NOT_AVAILABLE' );
		$type = 'error';
		$app =& JFactory::getApplication();
		$app->enqueueMessage($msg,$type);
	}
	
	/**
	 * Add the page title and toolbar.
	 */
	protected function addToolbar()
	{
		$canDo	= CollectorHelper::getActions();
		$user		= JFactory::getUser();
		JToolBarHelper::title(JText::_('COM_COLLECTOR_TEMPLATES_MANAGER'), 'thememanager');

		// if ($canDo->get('core.create') || (count($user->getAuthorisedCategories('com_collector', 'core.create'))) > 0 ) {
			// JToolBarHelper::addNew('item.add','JTOOLBAR_NEW');
		// }

		// if (($canDo->get('core.edit')) || ($canDo->get('core.edit.own'))) {
			// JToolBarHelper::editList('item.edit','JTOOLBAR_EDIT');
		// }

		// JToolBarHelper::custom('items.history', 'preview', 'preview', 'COM_COLLECTOR_HISTORY');

		// if ($canDo->get('core.edit.state')) {
			// JToolBarHelper::divider();
			// JToolBarHelper::custom('items.publish', 'publish.png', 'publish_f2.png','JTOOLBAR_PUBLISH', true);
			// JToolBarHelper::custom('items.unpublish', 'unpublish.png', 'unpublish_f2.png', 'JTOOLBAR_UNPUBLISH', true);
			// JToolBarHelper::divider();
			// JToolBarHelper::archiveList('items.archive','JTOOLBAR_ARCHIVE');
			// JToolBarHelper::custom('items.checkin', 'checkin.png', 'checkin_f2.png', 'JTOOLBAR_CHECKIN', true);
		// }

		// if ($this->state->get('filter.published') == -2 && $canDo->get('core.delete')) {
			// JToolBarHelper::deleteList('', 'items.delete','JTOOLBAR_EMPTY_TRASH');
		// }
		// else if ($canDo->get('core.edit.state')) {
			// JToolBarHelper::trash('items.trash','JTOOLBAR_TRASH');
		// }
	}
}

}
?>
