<?php
/**
 * Joomla! 1.5 component Collector
 *
 * @version 	$Id: item.php 134 2012-04-05 20:45:38Z steevo $
 * @author 		Philippe Ousset steevo@steevo.fr
 * @package 	Collector
 * @license 	GNU/GPL
 *
 * Collector is a Multi Purpose Listing Tool.
 * Originaly developped to list Collections
 * it can be used for several purpose.
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

if(version_compare(JVERSION,'1.6.0','<')){
//Code pour Joomla! 1.5

jimport( 'joomla.application.component.controller' );

/**
 * Item Controller
 *
 * @package  	Collector
 */
class CollectorControllerItem extends CollectorController
{
	/**
	 * Method to save an item
	 *
	 * @access	public
	 */
	function save()
	{
		$option = JRequest::getCmd( 'option' );
		$view = JRequest::getCmd( 'view' );
		$collection = JRequest::getCmd( 'collection' );
		$item = JRequest::getString( 'id' );
		$itemid = JRequest::getCmd( 'Itemid' );

		$model = $this->getModel('item');

		if (!$model->store())
		{
			$msg = JText::_( 'COM_COLLECTOR_ERROR_SAVE' );
		}

		if ( $item != 0 )
		{
			$this->setRedirect( JRoute::_('index.php?option='.$option.'&view='.$view .'&id='.$collection.'&item='.$item.'&Itemid='.$itemid), $msg );
		}
		else
		{
			$this->setRedirect( JRoute::_('index.php'), $msg );
		}
	}

	/**
	 * Cancels an edit article operation
	 *
	 * @access	public
	 */
	function cancel()
	{
		$this->setRedirect( JRoute::_('index.php'), $msg );
	}

	/**
	 * Method to display a view
	 *
	 * @access	public
	 */
	function display()
	{
		parent::display();
	}
}

}else{
//Code pour Joomla >= 1.6.0

jimport('joomla.application.component.controllerform');
/**
 * Item Controller
 *
 * @package  	Collector
 */
class CollectorControllerItem extends JControllerForm
{
	public function delete()
    {
        // Check for request forgeries
        JRequest::checkToken() or die(JText::_('JINVALID_TOKEN'));
 
        // Get item to remove from the request.
        $id = JRequest::getInt('id');
        $collection = JRequest::getInt('collection');
 
		// Get the model.
		$model = $this->getModel();

		// Remove the items.
		if ($model->delete($id))
		{
			$this->setMessage(JText::_('COM_COLLECTOR_ITEM_DELETED'));
		}
		else
		{
			$this->setMessage($model->getError());
		}
 
        $this->setRedirect(JRoute::_('index.php?option=' . $this->option . '&view=collection&collection=' . $collection, false));
    }
	
	/**
	 * Method override to check if you can add a new record.
	 *
	 * @param	array	An array of input data.
	 *
	 * @return	boolean
	 * @since	1.6
	 */
	protected function allowAdd($data = array())
	{
		// Initialise variables.
		$user	= JFactory::getUser();
		$allow	= $user->authorise('core.create', 'com_collector');

		if ($allow === null) {
			// In the absense of better information, revert to the component permissions.
			return parent::allowAdd();
		}
		else {
			return $allow;
		}
	}
	
	/**
	 * Method override to check if you can edit an existing record.
	 *
	 * @param	array	$data	An array of input data.
	 * @param	string	$key	The name of the key for the primary key.
	 *
	 * @return	boolean
	 */
	protected function allowEdit($data = array(), $key = 'id')
	{
		// Initialise variables.
		$recordId	= (int) isset($data[$key]) ? $data[$key] : 0;
		$user		= JFactory::getUser();
		$userId		= $user->get('id');

		// Check general edit permission first.
		if ($user->authorise('core.edit', 'com_collector.item.'.$recordId)) {
			return true;
		}

		// Fallback on edit.own.
		// First test if the permission is available.
		if ($user->authorise('core.edit.own', 'com_collector')) {
			// Now test the owner is the user.
			$ownerId	= (int) isset($data['created_by']) ? $data['created_by'] : 0;
			if (empty($ownerId) && $recordId) {
				// Need to do a lookup from the model.
				$record		= $this->getModel()->getItem($recordId);

				if (empty($record)) {
					return false;
				}

				$ownerId = $record->created_by;
			}

			// If the owner matches 'me' then do the test.
			if ($ownerId == $userId) {
				return true;
			}
		}

		// Since there is no asset tracking, revert to the component permissions.
		return parent::allowEdit($data, $key);
	}
	
	/**
	 * Method to get a model object, loading it if required.
	 *
	 * @param	string	$name	The model name. Optional.
	 * @param	string	$prefix	The class prefix. Optional.
	 * @param	array	$config	Configuration array for model. Optional.
	 *
	 * @return	object	The model.
	 * @since	1.5
	 */
	public function &getModel($name = '', $prefix = '', $config = array('ignore_request' => true))
	{
		$model = parent::getModel($name, $prefix, $config);

		return $model;
	}
	
	/**
	* Gets the URL arguments to append to a list redirect.
	*
	* @return    string    The arguments to append to the redirect URL.
	*/
	protected function getRedirectToListAppend()
	{
		$append = parent::getRedirectToListAppend();
		
		$form = JRequest::getVar('jform');
		
		$append .= '&view=collection&id='.$form['collection'];
		
		return $append;
	}
}

}