<?php
/**
 * Joomla! 1.5 component Collector
 *
 * @version 	$Id: install.collector.php 140 2012-04-09 15:17:22Z steevo $
 * @author 		Philippe Ousset steevo@steevo.fr
 * @package 	Collector
 * @license 	GNU/GPL
 *
 * Collector is a Multi Purpose Listing Tool.
 * Originaly developped to list Collections
 * it can be used for several purpose.
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

function com_install()
{
	global $mainframe; 
	
	$last_version = '0.5.0';
	$filename = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_collector' . DS . 'collector.xml';
	if (file_exists($filename) && is_readable($filename))
	{
		// get the version number
		$parser = JFactory::getXMLParser('Simple');
		$parser->loadFile($filename);
		$your_version = $parser->document->version[0]->data();
		unset($parser);
	}
	
	// collector est deja installe
	if (!empty($your_version)){
		if($your_version == $last_version)
		{
			// version a jour
			$message = "Votre version est &agrave; jour.</li><li>Your version is up to date.";
			JError::raiseWarning(100, $message);
			
			if(version_compare(JVERSION,'1.6.0','<')){
				//Code pour Joomla! 1.5
				$mainframe->redirect('index.php?option=com_installer');
			}else{
				//Code pour Joomla >= 1.6.0
				$app = JFactory::getApplication();
				$app->redirect('index.php?option=com_installer');
			}
		}
		else
		{
			// mise a jour
			upgrade_from_0_4_1($last_version);
		}
	}
	else
	{
		// installation
		new_install($last_version);
	}
	
	// correction du lien de menu
	if(version_compare(JVERSION,'1.6.0','>=')){
		$filename = JPATH_SITE . DS . 'components' . DS . 'com_collector' . DS . 'views' . DS . 'item'. DS . 'tmpl' . DS . 'form.php';
		JFile::delete($filename);
		$filename = JPATH_SITE . DS . 'components' . DS . 'com_collector' . DS . 'views' . DS . 'item'. DS . 'tmpl' . DS . 'form.xml';
		JFile::delete($filename);
		update_menu_link();
	}
}

function update_menu_link()
{
	$db =& JFactory::getDBO();
	$query = "SELECT id FROM `#__menu` WHERE title LIKE 'COM_COLLECTOR_DEFINED'";
	$db->setQuery($query);
	$id = $db->loadResult();
	
	$query = "UPDATE `#__menu` SET link = 'index.php?option=com_collector&view=lists' WHERE id = ".$id;
	$db->setQuery($query);
	$db->query();
	
	$db =& JFactory::getDBO();
	$query = "SELECT id FROM `#__menu` WHERE title LIKE 'COM_COLLECTOR_FIELDS'";
	$db->setQuery($query);
	$id = $db->loadResult();
	
	$query = "UPDATE `#__menu` SET link = 'index.php?option=com_collector&view=fields' WHERE id = ".$id;
	$db->setQuery($query);
	$db->query();
}

function new_install($last_version)
{
	global $mainframe;
	$db =& JFactory::getDBO();
	jimport('joomla.filesystem.folder');
	if(version_compare(JVERSION,'1.6.0','<')){
		//Code pour Joomla! 1.5
		$adminId = 62;
		$access = 0;
	}else{
		//Code pour Joomla >= 1.6.0
		$adminId = 42;
		$access = 1;
	}

	/*
	* Insertion des types de champs dans la table
	*/
	$query = "INSERT INTO `#__collector_fields_type` (
`id`, `type`, `unikable`, `sortable`, `searchable`,	`filterable`
) VALUES (
'1', 'line', '1', '1', '1', '0'
),(
'2', 'text', '0', '0', '1', '0'
),(
'3', 'define', '0', '1', '1', '1'
),(
'4', 'item', '0', '1', '1', '1'
),(
'5', 'image', '0', '0', '1', '0'
),(
'6', 'number', '1', '1', '1', '1'
),(
'7', 'date', '1', '1', '1', '1'
),(
'8', 'file', '0', '0', '1', '0'
);";

	$db->setQuery($query);
	$db->query();
	if ($db->getErrorNum()) {
		exit($db->stderr());
	}

	/*
	* Insertion de templates exemples
	*/
	$query = "INSERT INTO `#__collector_templates` (
`id` , `name`, `alias`, `collection` ,`client` ,`home` ,`column`
) VALUES (
1 , 'default listing', 'default', '0', '1', '0', '1'
),(
2 , 'default detail', 'default', '0', '2', '0', '1'
);";

	$db->setQuery($query);
	$db->query();
	if ($db->getErrorNum()) {
		exit($db->stderr());
	}

	/*
	* Insertion des types de fichiers dans la table
	*/
	$query = "INSERT INTO `#__collector_files_type` (
`id`, `name`, `text`
) VALUES (
'1', 'picture', 'IMG_DOC'
),(
'2', 'text', 'TXT_DOC'
),(
'3', 'calc', 'CALC_DOC'
),(
'4', 'pdf', 'PDF_DOC'
),(
'5', 'audio', 'AUDIO_DOC'
),(
'6', 'video', 'VIDEO_DOC'
),(
'7', 'other', 'OTHER_DOC'
);";

	$db->setQuery($query);
	$db->query();
	if ($db->getErrorNum()) {
		exit($db->stderr());
	}

	/*
	* Insertion des extensions de fichier dans la table
	*/
	$query = "INSERT INTO `#__collector_files_ext` (
`id` , `ext`, `type` ,`ico` ,`state`
) VALUES (
1 , 'jpg', '1', 'picture.png', '1'
),(
2 , 'png', '1', 'picture.png', '1'
),(
3 , 'bmp', '1', 'picture.png', '1'
),(
4 , 'gif', '1', 'picture.png', '1'
),(
5 , 'xcf', '1', 'picture.png', '0'
),(
6 , 'doc', '2', 'page_white_word.png', '1'
),(
7 , 'odt', '2', 'page_white_word.png', '1'
),(
8 , 'txt', '2', 'page_white_word.png', '1'
),(
9 , 'rtf', '2', 'page_white_word.png', '1'
),(
10 , 'xls', '3', 'page_white_excel.png', '1'
),(
11 , 'ods', '3', 'page_white_excel.png', '1'
),(
12 , 'pdf', '4', 'page_white_acrobat.png', '1'
);";

	$db->setQuery($query);
	$db->query();
	if ($db->getErrorNum()) {
		exit($db->stderr());
	}
	
	?>
	<center><img src="components/com_collector/assets/images/collector_logo.png" /></center>
	</br>
	<P style="font-size:large; font-weight:bold;" >Vous venez d'installer Collector, le composant de gestion de vos collections.</P>
	<?php
	
	if(version_compare(JVERSION,'1.6.0','>=')){
		//Code pour Joomla! 1.6
		// create field 'asset_id' in fields table
		$query = "ALTER TABLE `#__collector_fields` ADD `attribs` varchar(5120) NOT NULL AFTER `template`";
		$db->setQuery( $query );
		$db->query();
		
		$query = "ALTER TABLE `#__collector_fields` ADD `required` INT NOT NULL DEFAULT '0' AFTER `checked_out_time`";
		$db->setQuery( $query );
		$db->query();
		
		$query = "ALTER TABLE `#__collector_fields` DROP `template`";
		$db->setQuery( $query );
		$db->query();
		
		$query = "ALTER TABLE `#__collector_fields` DROP `defined`";
		$db->setQuery( $query );
		$db->query();
		?>
		<p style="color:#ff0000; font-size:x-large; font-weight:bold;" >Attention, si vous avez import&eacute; des donn&eacute;es de Joomla 1.5, vous devez mettre &agrave; jour vos donn&eacute;es :</br>Beware, if you import data from Joomla 1.5, you must update your data :</p>
		<table><tr><td>
		<div class="button1"><div class="next"><a id="update" rel="{handler: 'iframe', size: {x: 400, y: 200}}" href="index.php?option=com_collector&view=updatejoomla&tmpl=component" class="modal">Mettre &agrave; jour</a></div></div>
		</td></tr></table>
		<?php
	}
}

function upgrade_from_0_4_1($last_version)
{
	JHTML::_('behavior.modal');
	
	$db =& JFactory::getDBO();

	jimport('joomla.filesystem.file');

	// create users table
	$query = "CREATE TABLE IF NOT EXISTS `#__collector_users` (
	`id` int(11) NOT NULL auto_increment,
	`user` int(11) NOT NULL,
	`collection` int(11) NOT NULL,
	`perso` text NOT NULL,
	`perso_access` int(3) NOT NULL,
	`manco` text NOT NULL,
	`manco_access` int(3) NOT NULL,
	`dispo`text NOT NULL,
	`dispo_access` int(3) NOT NULL,
	PRIMARY KEY (`id`),
	KEY `idx_user` (`user`),
	KEY `idx_collection` (`collection`)
) ENGINE=MyISAM;";
	$db->setQuery( $query );
	$db->query();
	
	// modify field 'name' in fields table
	$query = "ALTER TABLE `#__collector_fields_type` CHANGE `name` `type` VARCHAR( 30 ) NOT NULL";
	$db->setQuery( $query );
	$db->query();
	
	// create field 'tablecolumn' in fields table
	$query = "ALTER TABLE `#__collector_fields` ADD `asset_id` int(10) unsigned NOT NULL DEFAULT '0' AFTER `id`";
	$db->setQuery( $query );
	$db->query();
	
	// create field 'description' in fields table
	$query = "ALTER TABLE `#__collector_fields` ADD `tablecolumn` TEXT NOT NULL AFTER `field`";
	$db->setQuery( $query );
	$db->query();
	
	// create field 'asset_id' in fields table
	$query = "ALTER TABLE `#__collector_fields` ADD `description` TEXT NOT NULL DEFAULT '' AFTER `field`";
	$db->setQuery( $query );
	$db->query();
	
	// create field 'asset_id' in collections table
	$query = "ALTER TABLE `#__collector` ADD `asset_id` int(10) unsigned NOT NULL DEFAULT '0' AFTER `id`";
	$db->setQuery( $query );
	$db->query();
	
	if(version_compare(JVERSION,'1.6.0','<')){
		//Code pour Joomla! 1.5
	}else{
		//Code pour Joomla >= 1.6.0
		include JPATH_ADMINISTRATOR.DS.'components'.DS.'com_collector'.DS.'tables'.DS.'collector.php';
		$table = JTable::getInstance('Collector','Table');
		
		$query = "SELECT id FROM `#__collector`";
		$db->setQuery($query);
		$results = $db->loadObjectList();
		foreach ($results as $result)
		{
			$table->load($result->id);
			$table->store();
		}
		
		include JPATH_ADMINISTRATOR.DS.'components'.DS.'com_collector'.DS.'tables'.DS.'collector_fields.php';
		$table = JTable::getInstance('Collector_fields','Table');
		
		$query = "SELECT id FROM `#__collector_fields`";
		$db->setQuery($query);
		$results = $db->loadObjectList();
		foreach ($results as $result)
		{
			// $table->load($result->id);
			// $table->store();
		}
	}
	
	// create field 'asset_id' in fields table
	$query = "ALTER TABLE `#__collector_items` ADD `asset_id` int(10) unsigned NOT NULL DEFAULT '0' AFTER `id`";
	$db->setQuery( $query );
	$db->query();
	?>
	<center><img src="components/com_collector/assets/images/collector_logo.png" /></center>
	<P style="font-size:large; font-weight:bold;" >Vous venez d'installer Collector, le composant de gestion de vos collections.</P>
	<p style="color:#ff0000; font-size:x-large; font-weight:bold;" >Attention vous devez mettre &agrave; jour vos donn&eacute;es :</br>Beware you must update your data :</p>
	<table><tr><td>
	<div class="button1"><div class="next"><a id="update" rel="{handler: 'iframe', size: {x: 400, y: 200}}" href="index.php?option=com_collector&view=update&tmpl=component" class="modal">Mettre &agrave; jour</a></div></div>
	</td></tr></table>
	<?php
	$filename = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_collector' . DS . 'tables' . DS . 'collector_items_history.php';
	JFile::delete($filename);
	$filename = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_collector' . DS . 'tables' . DS . 'collector_items_values.php';
	JFile::delete($filename);
}
?>
