<?php
/**
 * Joomla! 1.5 component Collector
 *
 * @version 	$Id: view.html.php 131 2012-03-19 23:33:03Z steevo $
 * @author 		Philippe Ousset steevo@steevo.fr
 * @package 	Collector
 * @license 	GNU/GPL
 *
 * Collector is a Multi Purpose Listing Tool.
 * Originaly developped to list Collections
 * it can be used for several purpose.
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.application.component.view');

if(version_compare(JVERSION,'1.6.0','<')){
//Code pour Joomla! 1.5

/**
 * HTML Filelist View class for the Collector component
 *
 * @package	Collector
 */
class CollectorViewFilelist extends JView
{
	/**
	 * Display function
	 */
	function display($tpl = null)
	{
		global $mainframe;

		// Get data from the model
		$model =& $this->getModel('filelist');
		$lists =& $model->getList();
		$folder =& $model->getFolder();
		$type = $model->getType();
		$navigation =& $model->get_path_navigation();

		// Add a reference to a CSS file
		JHTML::stylesheet('select.css', 'components/com_collector/assets/');

		$this->assignRef( 'folder', $folder );
		$this->assignRef( 'type', $type );
		$this->assignRef( 'lists', $lists );
		$this->assignRef( 'navigation', $navigation );

		parent::display($tpl);
	}
}

}else{
//Code pour Joomla >= 1.6.0

/**
 * HTML Filelist View class for the Collector component
 *
 * @package	Collector
 */
class CollectorViewFilelist extends JView
{
	/**
	 * Display function
	 */
	function display($tpl = null)
	{
		// Get data from the model
		$model =& $this->getModel('filelist');
		$lists =& $model->getList();
		$folder =& $model->getFolder();
		$type = $model->getType();
		$navigation =& $model->get_path_navigation();
		
		$doc = JFactory::getDocument();
		$doc->addStyleSheet('components/com_collector/assets/css/select.css');
		
		$this->assignRef( 'folder', $folder );
		$this->assignRef( 'type', $type );
		$this->assignRef( 'lists', $lists );
		$this->assignRef( 'navigation', $navigation );
		
		parent::display($tpl);
	}
}

}
?>